function ReadFile(tname) {
    var tfile, ForReading = 1, retVal;
    try {
	   //fs=system.filesystem.GetFile(tname);
	   //alert(fs.Size);
       tfile = system.filesystem.OpenTextFile (tname, ForReading);
       retVal=tfile.ReadAll();
       tfile.Close();
       return retVal.replace(/\r/g,"").split("\n\n");
    }catch(e){
		if (tfile)
			tfile.Close();
		
		if (tname!="") {
			alert("Error opening file \""+tname+"\". Using built in quotes");
			options("xFile")="";
		}
		b=storage.openText("qod.txt");
		return b.replace(/\r/g,"").split("\n\n");
    }
}

function ShowOptionsDlg(wnd) {

	wnd.AddControl(gddWndCtrlClassLabel, 0, "", "Custom quotes file (leave blank for default)", 10, 10, 260, 60);
	xFileCtrl=wnd.AddControl(gddWndCtrlClassEdit, 0, "xFile", options("xFile"), 10, 30, 200, 24);
		
	var browse = wnd.AddControl(gddWndCtrlClassButton, gddWndCtrlTypeButtonPush, "browse", "Browse", 215, 30, 55, 24);

	browse.onClicked=new Function ("xFileCtrl.value=BrowseForFile( '*.txt');")

	wnd.AddControl(gddWndCtrlClassLabel, 0, "", "Quote change interval (second)", 10, 65, 160, 25);
	wnd.AddControl(gddWndCtrlClassEdit, 0, "periode", options("periode"), 170, 60, 40, 24);

	
	wnd.AddControl(gddWndCtrlClassLabel, 0, "", "Font type", 10, 95, 160, 24);
	
	var f = new Array("Arial","Comic Sans MS","Courier New","Impact","Lucida Sans","Tahoma","Trebuchet MS","Tunga","Times New Roman", "Verdana");
	dialogFont = wnd.AddControl(gddWndCtrlClassList, gddWndCtrlTypeListDrop, "fontType", f, 70, 90, 140, 24);
	dialogFont.value = options("fontType");
	
	
	wnd.AddControl(gddWndCtrlClassLabel, 0, "", "Font size", 10, 120, 160, 24);
	var fs= new Array("6","7","8","9","10","11","12","13","14","15","16");
	dialogFont = wnd.AddControl(gddWndCtrlClassList, gddWndCtrlTypeListDrop, "fontSize", fs, 70, 115, 140, 24);
	dialogFont.value = options("fontSize");
	
	
	var fontBoldCtrl= wnd.AddControl(gddWndCtrlClassButton, gddWndCtrlTypeButtonCheck, "fontBold",
    "Bold", 220, 90, 50, 24);
	fontBoldCtrl.value=options("fontBold");
	
	var fontItalicCtrl= wnd.AddControl(gddWndCtrlClassButton, gddWndCtrlTypeButtonCheck, "fontItalic",
    "Italic", 220, 115, 50, 24);
	fontItalicCtrl.value=options("fontItalic");
	
	wnd.AddControl(gddWndCtrlClassLabel, 0, "", "Align", 10, 145, 50, 24);
	var al= new Array("left","center","right");
	dialogAlign = wnd.AddControl(gddWndCtrlClassList, gddWndCtrlTypeListDrop, "fontAlign", al, 70, 140, 140, 24);
	dialogAlign.value = options("fontAlign");
	
	wnd.AddControl(gddWndCtrlClassLabel, 0, "", "Text Color", 10, 170, 260, 60);
	textColorCtrl=wnd.AddControl(gddWndCtrlClassEdit, 0, "textColor", options("textColor"), 70, 165, 80, 24);
	
	wnd.AddControl(gddWndCtrlClassLabel, 0, "", "Background", 10, 195, 260, 60);
	backgroundColorCtrl=wnd.AddControl(gddWndCtrlClassEdit, 0, "backgroundColor", options("backgroundColor"), 70, 190, 80, 24);
	
	var bow = wnd.AddControl(gddWndCtrlClassButton, gddWndCtrlTypeButtonPush, "bow", "Black on White", 160, 165,100, 24);

	bow.onClicked=new Function("textColorCtrl.value='#000000';backgroundColorCtrl.value='#FFFFFF'");

	var wob = wnd.AddControl(gddWndCtrlClassButton, gddWndCtrlTypeButtonPush, "wob", "White on Black", 160, 190,100, 24);

	wob.onClicked=new Function("textColorCtrl.value='#FFFFFF';backgroundColorCtrl.value='#000000'");

	wnd.AddControl(gddWndCtrlClassLabel, 0, "", "Color format: #RRGGBB\nWhere R,G,B represent Red, Green and Blue in double digit Hexadecimal value.\nValid range is 00 to FF or in decimal 0 to 255.\nFor example, dark green is #009900, light purple is #FFD0FF, cyan is #00FFFF and dark yellow is #A0A000", 10, 225, 260, 90);
	
	wnd.onClose = OptionsDlgClosed;
}

function OptionsDlgClosed(wnd, code) {
  if (code == gddIdOK) {

	if (options("xFile")!=wnd.GetControl("xFile").text) {
		options("xFile")=wnd.GetControl("xFile").text;
		quotes=ReadFile(options("xFile"));
	}
	
	p=new Number(wnd.GetControl("periode").value);
	if (p.valueOf() < 0.1) p=new Number(0.1);
	options("periode")=p.valueOf();
	periode=options("periode")*1000;
	if (periode<1000) {
    animTime=1;
  } else { animTime=500;}
  
//  if (animTime>1) {
  	clearInterval(nextQuote);
  	quote.opacity=255;
  	fadeOut();
	//}
	options("fontType")=wnd.GetControl("fontType").value;
	quote.font=options("fontType");
	
	options("fontSize")=wnd.GetControl("fontSize").value;
	quote.size=options("fontSize");
	
	options("fontBold")=wnd.GetControl("fontBold").value;
	quote.bold=options("fontBold");
	
	options("fontItalic")=wnd.GetControl("fontItalic").value;
	quote.italic=options("fontItalic");

	options("fontAlign")=wnd.GetControl("fontAlign").value;
	quote.align=options("fontAlign");
	
	tc=wnd.GetControl("textColor").value;
	if (tc.search(/^#[0-9a-f]{6}$/gi)==-1) {
		alert('Bad formed Text Color, reverting back to old value')
	} else { 
		options("textColor")=tc;
	}
	quote.color=options("textColor");
	quote.overColor=options("textColor");
	
	tc=wnd.GetControl("backgroundColor").value;
	if (tc.search(/^#[0-9a-f]{6}$/gi)==-1) {
		alert('Bad formed Background Color, reverting back to old value')
	} else { 
		options("backgroundColor")=tc;
	}
	
	quoteBack.background=options("backgroundColor");	
	
  }
}

function fadeOut() {
  	if (quote.opacity==255) {
  		clearInterval(nextQuote);
  		beginAnimation("fade()",255,0,animTime);
  		setTimeOut("fadeIn()",animTime);
  	}
}

function fadeIn() {
	quote.innerText=quotes[Math.round(Math.random()*(quotes.length-1))];
	beginAnimation("fade()", 0, 255, animTime);
	nextQuote=setInterval("fadeOut()",periode+animTime);
}

function fade() {
	quote.opacity=event.value;
	
}

view.caption = strTitle;


options.defaultValue("periode") = 60;
options.defaultValue("xFile") = "";
options.defaultValue("fontType") = "Arial";
options.defaultValue("fontSize") = "8";
options.defaultValue("fontBold") = false;
options.defaultValue("fontItalic") = false;
options.defaultValue("fontAlign") = "right";
options.defaultValue("textColor") = "#FFFFFF";
options.defaultValue("backgroundColor") = "#000000";
options.defaultValue("width")="200"
options.defaultValue("height")="200"

quote.font=options("fontType");
quote.size=options("fontSize");
quote.bold=options("fontBold");
quote.italic=options("fontItalic");
quote.align=options("fontAlign");	
quote.color=options("textColor");
quote.overColor=options("textColor");
quoteBack.background=options("backgroundColor");

var quotes=ReadFile(options("xFile"));
var periode=options("periode")*1000;
var animTime=500;
if (periode<1000) {
animTime=1;
}
var nextQuote=0;

plugin.onShowOptionsDlg = ShowOptionsDlg;

quote.onclick="if (animTime>1) {fadeOut();}";
fadeOut();

view.height=options("height")
view.width=options("width")

function viewSize() {
	options("width")=view.width;
	options("height")=view.height;
}
function viewMinimize() {
	alert('minimize');
}
